commit 5de0dc84c75a43f78a03c7cdb7e7c443c641a7fa
Author: Jakub Jelinek <jakub@redhat.com>
Date:   Wed Mar 4 09:01:59 2020 +0100

    tailcall: Fix up process_assignment [PR94001]
    
    When a function returns void or the return value is ignored, ass_var
    is NULL_TREE.  The tail recursion handling generally assumes DCE has been
    performed and so doesn't expect to encounter useless assignments after the
    call and expects them to be part of the return value adjustment that need
    to be changed into tail recursion additions/multiplications.
    process_assignment does some verification and has a way to tell the caller
    to try to move dead or whatever other stmts that don't participate in the
    return value modifications before it is returned.
    For binary rhs assignments it is just fine, neither op0 nor op1 will be
    NULL_TREE and thus if *ass_var is NULL_TREE, it will not match, but unary
    rhs is handled by only setting op0 to rhs1 and setting op1 to NULL_TREE.
    And at this point, NULL_TREE == NULL_TREE and thus we think e.g. the
      c_2 = -e_3(D);
    dead stmt is actually a return value modification, so we queue it as
    multiplication and then create a void type SSA_NAME accumulator for it
    and ICE shortly after.
    
    Fixed by making sure op1 == *ass_var comparison is done only if *ass_var.
    
    2020-03-04  Jakub Jelinek  <jakub@redhat.com>
    
            PR tree-optimization/94001
            * tree-tailcall.c (process_assignment): Before comparing op1 to
            *ass_var, verify *ass_var is non-NULL.
    
            * gcc.dg/pr94001.c: New test.

diff --git a/gcc/ChangeLog b/gcc/ChangeLog
index ec0284ad8be..3e93b3ae62b 100644
--- a/gcc/ChangeLog
+++ b/gcc/ChangeLog
@@ -1,3 +1,12 @@
+2020-03-17  Jakub Jelinek  <jakub@redhat.com>
+
+	Backported from mainline
+	2020-03-04  Jakub Jelinek  <jakub@redhat.com>
+
+	PR tree-optimization/94001
+	* tree-tailcall.c (process_assignment): Before comparing op1 to
+	*ass_var, verify *ass_var is non-NULL.
+
 2020-03-13  Richard Biener  <rguenther@suse.de>
 
 	PR tree-optimization/94163
diff --git a/gcc/testsuite/ChangeLog b/gcc/testsuite/ChangeLog
index 555d9965efd..bbc3bef437f 100644
--- a/gcc/testsuite/ChangeLog
+++ b/gcc/testsuite/ChangeLog
@@ -1,3 +1,11 @@
+2020-03-17  Jakub Jelinek  <jakub@redhat.com>
+
+	Backported from mainline
+	2020-03-04  Jakub Jelinek  <jakub@redhat.com>
+
+	PR tree-optimization/94001
+	* gcc.dg/pr94001.c: New test.
+
 2020-03-17  Kewen Lin  <linkw@gcc.gnu.org>
 
 	Backport from master
diff --git a/gcc/testsuite/gcc.dg/pr94001.c b/gcc/testsuite/gcc.dg/pr94001.c
new file mode 100644
index 00000000000..f83873fa2bd
--- /dev/null
+++ b/gcc/testsuite/gcc.dg/pr94001.c
@@ -0,0 +1,11 @@
+/* PR tree-optimization/94001 */
+/* { dg-do compile } */
+/* { dg-options "-O2 -fno-tree-dce" } */
+
+void
+bar (int e)
+{
+  bar (3);
+  int c;
+  c = -e;
+}
diff --git a/gcc/tree-tailcall.c b/gcc/tree-tailcall.c
index 255575f1198..4f42817f7de 100644
--- a/gcc/tree-tailcall.c
+++ b/gcc/tree-tailcall.c
@@ -327,7 +327,8 @@ process_assignment (gassign *stmt,
 	   && (non_ass_var = independent_of_stmt_p (op1, stmt, call,
 						    to_move)))
     ;
-  else if (op1 == *ass_var
+  else if (*ass_var
+	   && op1 == *ass_var
 	   && (non_ass_var = independent_of_stmt_p (op0, stmt, call,
 						    to_move)))
     ;

